// Functions to help simulate the real hardware.
// by Adam Pierce <adam@pierce.nf> for Call Direct.
// Created 22-Jul-2009

function setcookie(key, value, expiryseconds)
{
	if(!expiryseconds)
		expiryseconds = 3600;

	var dexp = new Date();
	dexp = new Date(dexp.getTime() + expiryseconds * 1000);
	document.cookie = key + '=' + value + '; expires=' + dexp.toGMTString() + '; path=/';
}


function getcookie(key)
{
	key += "=";
	var cookies = document.cookie.split(';');
	for(var i = 0; i < cookies.length; i++)
	{
		var c = cookies[i].replace(/(^\s*)/g, "");
		if(c.indexOf(key) == 0)
			return c.substring(key.length, c.length);
	}
	return null;
}


function delcookie(key)
{
	setcookie(key, '', -1);
}


function login(logname, password)
{
	if(logname == 'admin' && password == 'admin')
	{
		setcookie('login', 'ok');
		return true;
	}
	delcookie('login');
	return false;
}


function logout()
{
	delcookie('login');
}

function isLoggedIn()
{
	return getcookie('login');
}

function simulateUpdateStatus()
{
// The following replaces what the hardware would respond with:
	var simuptime = new Date();
	simuptime.setHours(1);
	var upstr = fmt2(simuptime.getHours()) + ' : ' + fmt2(simuptime.getMinutes()) + ' : ' + fmt2(simuptime.getSeconds());

	var portstat;
	if(simProduct == '3G17Wn')
		portstat = "1,100,F,0,10,H,1,100,F,"
	else
		portstat = "0,10,H,0,10,H,0,10,H,1,100,F,1,100,F,"

	return 'var SysUptime="' + upstr + '";'
	+'var opMode=1;'
	+'var connType="DHCP";'
	+'var pptpIP="";'
	+'var pptpPtP="";'
	+'var WanIp="203.22.33.44";'
	+'var subMask="255.255.255.255";'
	+'var Gateway="203.22.33.1";'
	+'var DNS1="203.22.0.3";'
	+'var DNS2="203.22.0.4";'
	+'var MacAdd="00:1D:85:DE:AD:07";'
	+'var portStatus="' + portstat + '";'
	+'var moduleName="Sierra MC8795V";'
	+'var csq="N/A";'
	+'var provider="Rhyan Telecom";'
	+'var WconnType="HSPA++";'
	+'var coverage="N/A";'
	+'var imei="3456547898876";'
	+'var freq="2100";'
	+'var wwanAPN="rhyan.connect";'
	+'var simStatus="N/A";'
	+'var st=[];';
}


function getUrlParams(name)
{
  name = name.replace(/[\[]/,"\\\[").replace(/[\]]/,"\\\]");
  var regexS = "[\\?&]"+name+"=([^&#]*)";
  var regex = new RegExp( regexS );
  var results = regex.exec( window.location.href );
  if( results == null )
    return null;
  else
    return results[1];
}


function simGetModel()
{
	var model = getUrlParams('model');
	if(model)
	{
		setcookie('model', model);
		return model;
	}
	
	model = getcookie('model');
	if(model)
		return model;

	return '3G18Wn';
}


var simProduct = simGetModel();

function simSetTitle()
{
	if(simProduct == '3G17Wn')
		document.getElementById('productTitle').innerHTML = '<h4><b style="font-size:16px">3G17Wn</b> - 3G 3-Port 11n Wi-Fi Router</h4>';
	else if(simProduct == '3G18Wn')
		document.getElementById('productTitle').innerHTML = '<h4><b style="font-size:18px;font-weight: normal;">3G8WV - 3G WiFi Router with Voice</h4>';
}


// Shows or hides menu items depending on whether the user is logged in.
function initMenu()
{
	simSetTitle();

//alert("dhcpen="+dhcpen+", opmode="+opmode+", storageb="+storageb);
//alert("opmode="+opmode+", storageb="+storageb);
	if(isLoggedIn())
	{
		document.getElementById("menu_login").style['display'] = 'none';
		document.getElementById("menu_syslog").style['display'] = 'none';
		//document.getElementById("dhcpcliinfo").style['display'] = '';


		initLanguage();
		if (dhcpen == "1")
		{
			document.getElementById( "dhcpcliinfo" ).style['display']='';
		}
		if ((opmode == '0' && dpbsta == '1' && ethconv == '1') || opmode == '2')
		{
			document.getElementById( "wirelessDiv1" ).style['display']='none';
			document.getElementById( "wirelessDiv2" ).style['display']='';
		}
		else
		{
			document.getElementById( "wirelessDiv1" ).style['display']='';
			document.getElementById( "wirelessDiv2" ).style['display']='none';
			if (opmode == '3')
				document.getElementById( "apcliDiv" ).style['display']='';
			if (ad == '1')
				document.getElementById( "ant_diversityDiv" ).style['display']='';
			if (meshb == "1")
				document.getElementById( "meshDiv" ).style['display']='';
		}
		if (storageb == "1")
		{
			document.getElementById( "storagebDiv" ).style['display']='';
			if (ftpb == "1")
				document.getElementById( "ftpbDiv" ).style['display']='';
			if (smbb == "1")
				document.getElementById( "smbbDiv" ).style['display']='';
			if (mediab == "1")
				document.getElementById( "mediabDiv" ).style['display']='';
		}
	
/*
		document.getElementById( "wirelessDiv1" ).style['display']='';
		document.getElementById( "wirelessDiv2" ).style['display']='none';
		if (opmode == '3')
			document.getElementById( "apcliDiv" ).style['display']='';
		if (ad == '1')
			document.getElementById( "ant_diversityDiv" ).style['display']='';
		if (meshb == "1")
			document.getElementById( "meshDiv" ).style['display']='';

*/
	}
	else
	{
		document.getElementById("menu_internet_settings").style['display'] = 'none';
		document.getElementById("menu_wireless_settings").style['display'] = 'none';
		document.getElementById("menu_firewall_settings").style['display'] = 'none';
		document.getElementById("menu_admin").style['display'] = 'none';
	}
	
	
	
}


function sim3GSelectCountry(country)
{
	var request = null;
	if(location.protocol == 'file:')
	{
		if(!request)try{ request=new ActiveXObject("MSXML2.XMLHTTP"); }catch(e){request=null;}
		if(!request)try{ request=new ActiveXObject("Microsoft.XMLHTTP"); }catch(e){request=null;}
    }
	if(!request)
		try{ request=new XMLHttpRequest(); } catch(e){request=null;}
	
    request.open("GET", '../internet/apnList.xml', false); 
    request.send(null);

    if(request.status==200 || request.status==0)
    {
    	var result = request.responseXML;
		if(!result.documentElement && request.responseStream)
			result.load(request.responseStream);

		var pos = result.documentElement.getElementsByTagName("Country");
		var countrylist = new Array();
		for(var i = 0; i < pos.length; i++)
			countrylist.push(pos[i].getAttribute('country'));
		
		for(var i = 0; i < pos.length; i++)
		{
			var c = pos[i];
			if(c.getAttribute('country') == country)
			{
				var result = "var st=[''";
				for(var j = 0; j < countrylist.length; j++)
					result = result + ",'" + countrylist[j] + "'";
				result = result + "];\n";
				result = result + "var selectedIdx=" + i + ";\n";
				result = result + "document.getElementById('nav2').innerHTML=\"<li class='top'><b style='color:#0000FF; text-decoration:underline;'>Choose an APN here</b><ul class='sub'>";
				var carrier = c.getElementsByTagName("Carrier");
				var defcarrier = null;
				for(var j = 0; j < carrier.length; j++)
				{
					var cc = carrier[j];
					var apn = cc.getElementsByTagName("APN");
					var defapn = "";
					if(apn.length > 0)
					{
						defapn = apn[0].getAttribute("apn");
						if(!defcarrier)
							defcarrier = defapn;
						result = result + "<li><span onClick=setAPN('" + defapn + "')>" + cc.getAttribute("carrier") + "</span><ul>";
						for(var k = 0; k < apn.length; k++)
						{
							var a = apn[k];
							result = result + "<li><span onClick=setAPN('" + a.getAttribute("apn") + "')>" + a.getAttribute("apn") + "</span></li>";
						}
						result = result + "</ul></li>";
					}
				}
				result = result + "</ul></li>\";document.getElementById('wwanAPN').value=\"" + defcarrier + "\";";
				return result;
			}
		}
	}
	return "";
}

